#Include "InterfaceFinder.Inc"
#Include "C:\RadASM\GoAsm\Inc\RadAsm.inc"

DATA SECTION
	hInstance		DD		0
	lpHandles		DD		0
	lpProcs			DD		0
	lpData			DD		0

	hSubMenu		DD		0
	AddInID			DD		0

CONST SECTION

	strMenuText			DB	"COM Interface Finder",0
	
	Interfaces			DB	"Interface",0
	szBaseString		DB	"#define GUID_IID_",0
	szPrefix			DB	" <0",0
	szSuffix			DB	"h, 0",0
	
	szMasmBaseString	DB	"GUID_IID_",0
	szMasmPrefix		DB	" Textequ <{0",0
	AddinOpt			ADDINOPT <0,0,0>

CODE SECTION

GetOptions:
	mov eax,offset AddinOpt
	ret

DllEntryPoint	FRAME hInst, reason, reserved1
    mov eax,[hInst]
    mov [hInstance], eax
    xor eax, eax
    inc eax
    ret
ENDF

InstallDll	FRAME hWin, fOpt
	invoke SendMessage, [hWin], AIM_GETHANDLES, 0, 0
	mov	[lpHandles], eax
	invoke SendMessage, [hWin], AIM_GETPROCS, 0, 0
	mov [lpProcs], eax
	invoke SendMessage, [hWin], AIM_GETDATA, 0, 0
	mov [lpData], eax
	mov ecx, 4
	add ecx, [eax+ADDINDATA.fMaximized]
	push ecx
	invoke SendMessage, [hWin], AIM_GETMENUID, 0, 0
	mov [AddInID], eax
	invoke SendMessage, [hWin], AIM_GETHANDLES, 0, 0
	push [eax+ADDINHANDLES.hMenu]
	call GetSubMenu
	mov [hSubMenu], eax
	invoke AppendMenu, eax, MF_STRING, [AddInID], offset strMenuText

	mov eax, RAM_COMMAND | RAM_INITMENUPOPUP
	ret
ENDF

DllProc	FRAME hWin, uMsg, wParam, lParam

	cmp D[uMsg], AIM_COMMAND
	jnz >.INITMENUPOPUP
		mov eax, [wParam]
		cmp [AddInID], eax
		jnz >.ExitMsgLoop
			mov eax,[lpHandles]
			mov eax,[eax+ADDINHANDLES.hWnd]
			invoke DialogBoxParam,[hInstance],1000,NULL,offset DlgProc,0
			mov eax,TRUE
			ret

	.INITMENUPOPUP
	cmp D[uMsg], AIM_INITMENUPOPUP
	jnz >.ExitMsgLoop
		mov eax, [lpData]
		mov eax, [eax+ADDINDATA.fProject]
		xor eax, 1
		or eax, MF_BYCOMMAND
		invoke EnableMenuItem, [hSubMenu], [AddInID], eax

	.ExitMsgLoop
	xor eax, eax
	ret
ENDF

DlgProc FRAME hwnd, uMsg, wParam, lParam
	uses edi,ebx,esi
	LOCAL szBuffer[256]			:B
	Local szResultString[256]	:B

	.WM_INITDIALOG
	cmp D[uMsg], WM_INITDIALOG
	jne >>.WM_COMMAND
		invoke ListInterfaces,[hwnd]
		invoke GetDlgItem,[hwnd],1001
		invoke SetFocus,eax
		xor eax,eax
		ret

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WM_CLOSE
		mov ebx, [wParam]
		and ebx, 0FFFFh
		cmp ebx,1
		jne >
			// Find the interface selected
			invoke SendDlgItemMessage,[hwnd],1001,LB_GETCURSEL,0,0
			test eax,eax
			js >>.EXIT
			invoke SendDlgItemMessage,[hwnd],1001,LB_GETTEXT,eax,offset szBuffer

			invoke EnumerateInterfaces,offset szBuffer,offset szResultString

			mov eax,[lpHandles]
			invoke SendMessage,[eax+ADDINHANDLES.hEdit],EM_REPLACESEL,TRUE,offset szResultString
			invoke PostMessage,[hwnd],WM_CLOSE,0,0
			jmp >>.EXIT
		:
		cmp ebx,2
		jne >>.EXIT
			invoke PostMessage,[hwnd],WM_CLOSE,0,0
			jmp >>.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.EXIT
		// End this dialog with that value as a return
		invoke EndDialog,[hwnd],0
		jmp >.EXIT

	.EXIT
	xor eax,eax
	RET

ENDF

ListInterfaces FRAME hwnd
	uses ebx
	LOCAL cCount					:D
	LOCAL hKey						:D
	LOCAL hSubKey					:D
	LOCAL cbKeyName					:D
	LOCAL Type						:D
	LOCAL cbValueData				:D
	LOCAL ValueData[256]			:B
	LOCAL ftLastWrite				:FILETIME
	LOCAL KeyName[256]				:B
	LOCAL ValueName[256]			:B
	LOCAL SubKeyName[256]			:B

	invoke RegOpenKeyEx,HKEY_CLASSES_ROOT, offset Interfaces, 0, KEY_ALL_ACCESS, offset hKey
	test eax,eax
	jnz >>.EXIT
		xor ebx,ebx
		mov [KeyName], ebx
		:
		mov D[cbKeyName], 256
		invoke RegEnumKeyEx,[hKey], ebx,offset KeyName,offset cbKeyName, NULL, NULL, NULL, offset ftLastWrite
		inc ebx
		cmp eax, ERROR_NO_MORE_ITEMS
		je >>
			mov D[ValueData],0
			invoke lstrcpy,offset SubKeyName, offset Interfaces
			invoke lstrcat,offset SubKeyName, "\"
			invoke lstrcat,offset SubKeyName, offset KeyName
			invoke RegOpenKeyEx,HKEY_CLASSES_ROOT, offset SubKeyName, 0, KEY_ALL_ACCESS, offset hSubKey
			test eax,eax
			jnz <<
			invoke RegEnumValue, [hSubKey], 0, offset ValueName, offset cbKeyName, 0, offset Type, offset ValueData, offset cbValueData
			invoke RegCloseKey,[hSubKey]
			mov al,[ValueData]
			test al,al
			jz <<
			invoke SendDlgItemMessage,[hwnd],1001,LB_ADDSTRING,0,offset ValueData
			jmp <<
	:
	.CloseKey
	invoke RegCloseKey,[hKey]
	.EXIT

	RET
ENDF

EnumerateInterfaces FRAME pInterfaceReq, pResult
	uses ebx,edi
	LOCAL cCount					:D
	LOCAL hKey						:D
	LOCAL hSubKey					:D
	LOCAL cbKeyName					:D
	LOCAL Type						:D
	LOCAL cbValueData				:D
	LOCAL ValueData[256]			:B
	LOCAL ftLastWrite				:FILETIME
	LOCAL KeyName[256]				:B
	LOCAL ValueName[256]			:B
	LOCAL InterfaceString[256]		:B
	LOCAL ItemFound					:D
	LOCAL SubKeyName[256]			:B

	mov D[ItemFound],FALSE
	invoke RegOpenKeyEx,HKEY_CLASSES_ROOT, offset Interfaces, 0, KEY_ALL_ACCESS, offset hKey
	test eax,eax
	jnz >>.EXIT
		xor ebx,ebx
		mov [KeyName], ebx
		:
		mov D[cbKeyName], 256
		invoke RegEnumKeyEx,[hKey], ebx,offset KeyName,offset cbKeyName, NULL, NULL, NULL, offset ftLastWrite
		inc ebx
		cmp eax, ERROR_NO_MORE_ITEMS
		je >>
			mov D[ValueData],0
			invoke lstrcpy,offset SubKeyName, offset Interfaces
			invoke lstrcat,offset SubKeyName, "\"
			invoke lstrcat,offset SubKeyName, offset KeyName
			invoke RegOpenKeyEx,HKEY_CLASSES_ROOT, offset SubKeyName, 0, KEY_ALL_ACCESS, offset hSubKey
			test eax,eax
			jnz <<
			invoke RegEnumValue, [hSubKey], 0, offset ValueName, offset cbKeyName, 0, offset Type, offset ValueData, offset cbValueData
			invoke RegCloseKey,[hSubKey]
			invoke lstrcmpi,offset ValueData,[pInterfaceReq]
			test eax,eax
			jnz <<
				mov D[ItemFound],TRUE

				mov edi,[lpData]
				add edi,ADDINDATA.szAssembler
				invoke lstrcmpi,edi,"masm"
				or eax,eax
				jnz >.Goasm
					invoke MASMParseGUID,offset KeyName,offset ValueData,offset InterfaceString
					jmp >.done
				.Goasm
				invoke lstrcmpi,edi,"goasm"
				or eax,eax
				jnz >.Default
					invoke GoAsmParseGUID,offset KeyName,offset ValueData,offset InterfaceString
					jmp >.done
				.Default
					invoke MASMParseGUID,offset KeyName,offset ValueData,offset InterfaceString
				.done

				invoke lstrcpy,[pResult],offset InterfaceString
			.KEYNOTUSEFUL
			jmp <<
	:
	invoke RegCloseKey,[hKey]
	.EXIT
	
	cmp D[ItemFound],TRUE
	je >
;		PrintText("Interface not found")
	:
	RET
ENDF

GoAsmParseGUID FRAME pGuid,pInterface,pOut
	LOCAL szTemp[256]		:B	

	invoke lstrcpy,[pOut],offset szBaseString
	invoke lstrcat,[pOut],[pInterface]
	invoke lstrcat,[pOut],offset szPrefix
	mov edi,[pGuid]
	inc edi
	invoke lstrcpyn,offset szTemp,edi,9
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,9
	invoke lstrcpyn,offset szTemp,edi,5
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,5
	invoke lstrcpyn,offset szTemp,edi,5
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,5
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,3
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix

	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],"h>"
	
	RET
ENDF

MASMParseGUID FRAME pGuid,pInterface,pOut
	LOCAL szTemp[256]		:B	

	invoke lstrcpy,[pOut],offset szMasmBaseString
	invoke lstrcat,[pOut],[pInterface]
	invoke lstrcat,[pOut],offset szMasmPrefix
	mov edi,[pGuid]
	inc edi
	invoke lstrcpyn,offset szTemp,edi,9
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,9
	invoke lstrcpyn,offset szTemp,edi,5
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,5
	invoke lstrcpyn,offset szTemp,edi,5
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],"h {0"

	add edi,5
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,3
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix

	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],offset szSuffix
	
	add edi,2
	invoke lstrcpyn,offset szTemp,edi,3
	invoke lstrcat,[pOut],offset szTemp
	invoke lstrcat,[pOut],"h}}>"
	
	RET
ENDF
